import csv
import json
import os
import pandas as pd
import requests
import sys
import argparse
import datetime
from selenium import webdriver
from urllib.parse import urlparse, urljoin
from selenium.common.exceptions import WebDriverException
from selenium.webdriver.chrome.options import Options
# Initialize the Selenium webdriver
from selenium.webdriver.common.by import By
from bs4 import BeautifulSoup
# Configure Chrome options to clear cache and disable extensions
chrome_options = Options()
#chrome_options.add_argument('--headless')
# Set the download directory for PDFs
download_directory = "/home/a/zhoujl/Downloads/all_web_crawler_pdf"  # Replace with the actual directory
prefs = {"download.default_directory": download_directory}
chrome_options.add_experimental_option("prefs", prefs)

successed_links = {}
visited_links = set()
broken_links = {}
denied_links = {}
broken_image = {}
successed_image = set()
merged_broken_links = {}


# Function to configure and retrieve WebDriver with authenticated session
def get_authenticated_driver(username, password, login_url):
    driver = webdriver.Chrome(options=chrome_options)

    # Navigate to the login page
    driver.get(login_url)
    if username != '' or password != '':
        # Fill in and submit the login form
        username_field = driver.find_element(By.NAME, 'user')
        password_field = driver.find_element(By.NAME, 'pass')
        login_button = driver.find_element(By.XPATH, '//input[@type="submit"]')

        username_field.send_keys(username)
        password_field.send_keys(password)
        login_button.click()

        # Wait for the login to complete, you might need to adjust this
        driver.implicitly_wait(2000)

    # Retrieve and return the cookies
    cookies = driver.get_cookies()
    return driver, cookies

def check_webpage(url, target_string, session, cookies=None):
    try:
        response = session.get(url, cookies=cookies)
        response.raise_for_status()  # Raise an exception for bad status codes
        content = response.text

        if target_string in content:
            return True, content
        else:
            return False, content
    except requests.exceptions.RequestException as e:
        return False, str(e)

# Set the main domain
def is_internal_link(link):
    parsed_link = urlparse(link)

    return parsed_link.netloc == main_domain and parsed_link.path.startswith(target_path) or parsed_link.netloc == ""


def find_broken_links(driver, url, current_depth, cookies, session, requests_cookies, target_string):
    global successed_links
    global visited_links
    global broken_links
    global denied_links
    global broken_image
    global successed_image

    if current_depth == 0 or url in broken_links:
        return "done"


    try:
        driver.get(url)
        if url.endswith(".pdf"):
            driver.back()
        else:
            #links = [a for a in driver.find_elements(By.TAG_NAME, "a")]
            links = [a.get_attribute("href") for a in driver.find_elements(By.TAG_NAME, "a")]
            images = [img.get_attribute("src") for img in driver.find_elements(By.TAG_NAME, "img")]
            #links.append('https://www.math.uzh.ch/home22')

            for link in links:
                #print(f'this {link} is',is_internal_link(link))
                #href_link = link.get_attribute("href")

                #text_link = link.get_attribute()
                if link and is_internal_link(link):
                    full_link = urljoin(url, link)
                    if full_link not in visited_links:
                        try:
                            visited_links.add(full_link)
                            response = requests.head(full_link)
                            checkBool, content = check_webpage(full_link, target_string, session, cookies=requests_cookies)
                            if response.status_code == 404:

                                broken_links.setdefault(full_link, [None, None, None, None])[0] = full_link
                                broken_links[full_link][1] = response.status_code
                                broken_links[full_link][2] = str(checkBool)
                                broken_links[full_link][3] = url

                               # print(f"Broken link: {full_link}")
                            if response.status_code == 403:
                                denied_links.setdefault(full_link, [None, None, None, None])[0] = full_link
                                denied_links[full_link][1] = response.status_code
                                denied_links[full_link][2] = str(checkBool)
                                denied_links[full_link][3] = url
                            else:
                                find_broken_links(driver, full_link, current_depth -1, cookies, session, requests_cookies, target_string)
                                if full_link not in broken_links:
                                    successed_links.setdefault(full_link, [None, None, None, None])[0] = full_link
                                    successed_links[full_link][1] = response.status_code
                                    successed_links[full_link][2] = str(checkBool)
                                    successed_links[full_link][3] = url
                                    # print(full_link)# Recursively check this link
                                    # print("keine fehler")
                                    # print('current_depth is:', current_depth)

                            if checkBool == True:
                                print('Path redirects to home')
                            # print("---------------------------------------")
                        except Exception as e:
                            print(f"Error checking link {full_link}: {e}")

            for image in images:
                if image and is_internal_link(image):
                    full_image_link = urljoin(url, image)
                    if full_image_link not in visited_links:
                        visited_links.add(full_image_link)
                        try:
                            response = requests.head(full_image_link)
                            if response.status_code == 404:
                                broken_image.setdefault(full_image_link, [None, None, None, None])[0] = full_image_link
                                broken_image[full_image_link][1] = response.status_code
                                broken_image[full_image_link][2] = ''
                                broken_image[full_image_link][3] = url

                                #print(f"Broken image: {full_image_link}")
                            else:
                                successed_image.add(full_image_link)
                        except Exception as e:
                             print(f"Error checking image {full_image_link}: {e}")
    except WebDriverException as e:
        print(f"Error accessing URL {url}: {e}")



def print_header(log_file, blacklists):

    if log_file.endswith("detail.log"):
         with open(log_file, "a+") as file:
            file.write("Skript: Web_crawler.py\n")
            file.write("Details Log " + formatted_datetime)
            file.write("\nInput URL:" + input_url)
            file.write("\nDOMAIN:" + main_domain)
            file.write("\n-------------------------------------\n")
            file.write("\nBlacklist : \n")
            for blacklist in blacklists:
                file.write(f"\"{blacklist}\"\n")
            file.write("-------------------------------------\n")
    elif log_file.endswith("summary.log"):
        with open(log_file, "a+") as file:
            file.write("Skript: Web_crawler.py\n")
            file.write("Summary Log " + formatted_datetime)
            file.write("\nInput URL:" + input_url)
            file.write("\nDOMAIN:" + main_domain)
            file.write("\n-------------------------------------\n")
    else:
        return  print("No summary.log or detail.log are found")




def print_detail_log(links, title, detail_log_file):
    with open(detail_log_file, "a") as file:
        file.write("\n" + title + ":\n\n")
        if len(links) == 0:
            file.write("Nothing found.\n---------------------------------------\n")
        for full_link, details in links.items():
            target_link = details[0]
            response = details[1]  # assuming the status_code is at index 0
            redirect = details[2]  # assuming the redirect flag is at index 1
            url = details[3]
            file.write("Page URL: " + url + "\n")
            file.write("Target URL: " + target_link + "\n")
            file.write("RESPONSE: " + str(response) + "\n")
            if title != 'Broken images' and redirect == True:
                file.write("REDIRECT_TO_HOME: " + str(redirect) + "\n")
            file.write("---------------------------------------\n")


def print_summary(checked_links,broken_links,checked_image,broken_image, summary_log_file, title):
    with open(summary_log_file, "a") as file:
        file.write(f"\n Checked links: {len(checked_links)+len(broken_links)}")
        file.write(f"\n Broken links: {len(broken_links)}")
        file.write(f"\n Checked image: {len(checked_image)+len(broken_image)}")
        file.write(f"\n Broken image: {len(broken_image)}")
        file.write("\n---------------------------------------")
        if len(broken_links) > 0 or len(broken_image) > 0:
            file.write(f"\nSome issue in \"{title}\"")
        else:
            file.write("\nEverything is ok")

def write_broken_links_to_csv(broken_links, csv_file):
    header = ["Response Code", "PAGE URL", "Link Text", "Target URL"]

    with open(csv_file, "a", newline="", encoding="utf-8") as file:
        # Check if the file is empty
        is_empty = file.tell() == 0

        writer = csv.writer(file)

        if is_empty:
            writer.writerow(header)

        for link, details in broken_links.items():
            target_url = details[0]
            response_code = details[1]
            url = details[3]
            link_text = " "
            writer.writerow([response_code, url, link_text, target_url])

def clear_arrays():
    successed_links.clear()
    visited_links.clear()
    broken_links.clear()
    denied_links.clear()
    broken_image.clear()
    successed_image.clear()
    merged_broken_links.clear()



if __name__ == "__main__":
    # if len(sys.argv) < 3 or not sys.argv[1].strip():
    #     print("Usage:python script.py conf.json <index or all>")
    #     sys.exit(1)
    #
    # parser = argparse.ArgumentParser(description='Web Crawling.')
    # parser.add_argument('conf_file', type=str, help='Path to the conf.json file')
    # #parser.add_argument('element_index', type=int, help='Index of the element to check in allSites')
    # args = parser.parse_args()

    conf_file_path = "conf.json"#args.conf_file

    with open(conf_file_path, "r") as conf_file:
        conf_data = json.load(conf_file)

    all_sites = conf_data.get("allSites", [])
    selected_arg = "all" #sys.argv[3]  # Get the third argument

    try:
        if selected_arg == "all":
            for selected_site in conf_data.get("allSites", []):
                max_depth = selected_site.get("max_depth")
                input_url = selected_site.get("startUrl")
                main_domain = urlparse(input_url).netloc
                target_path = selected_site.get("target_path")

                # Load the blacklist URLs from the JSON data
                blacklist = selected_site.get("blacklist", [])

                # Initialize the visited_links set with the URLs from the blacklist
                visited_links = set(blacklist)

                # Login credentials
                login_url = selected_site.get("login_url") or input_url
                username = selected_site.get("username")
                password = selected_site.get("password")
                target_string = selected_site.get("target_string")

                session = requests.Session()
                # target_string = 'Login/out'
                driver, cookies = get_authenticated_driver(username, password, login_url)
                requests_cookies = {cookie['name']: cookie['value'] for cookie in cookies}
                current_datetime = datetime.datetime.now()
                formatted_datetime = current_datetime.strftime("%Y-%m-%d %H:%M")

                parsed_url = urlparse(input_url)
                detail_file_name = parsed_url.netloc + parsed_url.path.replace("/", "_") + "_detail.log"
                detail_log_file = os.path.join(os.getcwd(), detail_file_name)

                summary_log_file = parsed_url.netloc + parsed_url.path.replace("/", "_") + "_summary.log"
                title = parsed_url.netloc + parsed_url.path

                # print header in files
                print_header(detail_log_file, blacklist)
                print_header(summary_log_file, blacklist)
                # function find_broken_links
                find_broken_links(driver, input_url, max_depth, cookies, session, requests_cookies, target_string)

                merged_broken_links = {**broken_links, **broken_image}

                # Clean up
                driver.quit()

                print_summary(successed_links, broken_links, successed_image, broken_image, summary_log_file, title)
                print_detail_log(broken_links, 'Broken links', detail_log_file)
                print_detail_log(broken_image, 'Broken images', detail_log_file)
                print_detail_log(denied_links, 'Denied links', detail_log_file)
                print_detail_log(successed_links, 'Successed links', detail_log_file)
                file_name = parsed_url.netloc + parsed_url.path.replace("/", "_")
                file_path = f"/home/a/zhoujl/Documents/broken_link_{file_name}.csv"
                write_broken_links_to_csv(merged_broken_links, file_path)
                print(f"Broken links found in {input_url}: {len(broken_links)}")
                clear_arrays()
        else:
            selected_index = int(selected_arg)
            if selected_index >= 0 and selected_index < len(conf_data.get("allSites", [])):
                selected_site = conf_data["allSites"][selected_index]
                max_depth = selected_site.get("max_depth")
                input_url = selected_site.get("startUrl")
                main_domain = urlparse(input_url).netloc
                target_path = selected_site.get("target_path")

                # Load the blacklist URLs from the JSON data
                blacklist = selected_site.get("blacklist", [])

                # Initialize the visited_links set with the URLs from the blacklist
                visited_links = set(blacklist)

                # Login credentials
                login_url = selected_site.get("login_url") or input_url
                username = selected_site.get("username")
                password = selected_site.get("password")
                target_string = selected_site.get("target_string")

                session = requests.Session()
                # target_string = 'Login/out'
                driver, cookies = get_authenticated_driver(username, password, login_url)
                requests_cookies = {cookie['name']: cookie['value'] for cookie in cookies}
                current_datetime = datetime.datetime.now()
                formatted_datetime = current_datetime.strftime("%Y-%m-%d %H:%M")

                parsed_url = urlparse(input_url)
                detail_file_name = parsed_url.netloc + parsed_url.path.replace("/", "_") + "_detail.log"
                detail_log_file = os.path.join(os.getcwd(), detail_file_name)

                summary_log_file = parsed_url.netloc + parsed_url.path.replace("/", "_") + "_summary.log"
                title = parsed_url.netloc + parsed_url.path

                # print header in files
                print_header(detail_log_file, blacklist)
                print_header(summary_log_file, blacklist)
                # function find_broken_links
                find_broken_links(driver, input_url, max_depth, cookies, session, requests_cookies, target_string)

                merged_broken_links = {**broken_links, **broken_image}

                # Clean up
                driver.quit()

                print_summary(successed_links, broken_links, successed_image, broken_image, summary_log_file, title)
                print_detail_log(broken_links, 'Broken links', detail_log_file)
                print_detail_log(broken_image, 'Broken images', detail_log_file)
                print_detail_log(denied_links, 'Denied links', detail_log_file)
                print_detail_log(successed_links, 'Successed links', detail_log_file)
                file_name = parsed_url.netloc + parsed_url.path.replace("/", "_")
                file_path = f"/home/a/zhoujl/Documents/broken_link_{file_name}.csv"
                write_broken_links_to_csv(merged_broken_links, file_path)
                print(f"Broken links found in {input_url}: {len(broken_links)}")

                clear_arrays()
            else:
                print("Invalid index.")
                sys.exit(1)
    except Exception as e:
       print(e)







